stages:
  - build
  - dockerize
  - deploy2Test
  - acceptanceTests
  
variables:
  REPO_NAME: https://gitlab.com/sevcan.dog/todo-app-ui

buildAndTest:
  stage: build
  image: node
  script: 
    - npm ci
    - export NODE_OPTIONS=--openssl-legacy-provider
    - npm run build
    - CI=true npm test

dockerize:
  environment: test
  stage: dockerize
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  script:
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"${CI_REGISTRY}\":{\"auth\":\"$(printf "%s:%s" "${CI_REGISTRY_USER}" "${CI_REGISTRY_PASSWORD}" | base64 | tr -d '\n')\"}}}" > /kaniko/.docker/config.json
    - >-
      /kaniko/executor
      --context "${CI_PROJECT_DIR}"
      --dockerfile "${CI_PROJECT_DIR}/Dockerfile"
      --build-arg URL="$URL" --build-arg BROKER_URL="$BROKER_URL" --build-arg BROKER_TOKEN="$BROKER_TOKEN"
      --destination "${CI_REGISTRY_IMAGE}/to-do-app-ui:${CI_COMMIT_TAG}"

gke:
  environment: test
  stage: deploy2Test
  image: google/cloud-sdk
  script:
    - echo "$SERVICE_ACCOUNT"
    - echo "$SERVICE_ACCOUNT" > /tmp/${CI_PIPELINE_ID}.json
    - gcloud auth activate-service-account --key-file /tmp/${CI_PIPELINE_ID}.json
    - gcloud config set project todoapptest-1
    - gcloud config set compute/zone us-central1-c
    - gcloud container clusters get-credentials cluster-1
    - kubectl delete deployment todo-app-ui
    - kubectl apply -f ${CI_PROJECT_DIR}/ui-deployment.yaml

acceptanceTests:
  environment: test
  stage: acceptanceTests
  image: node
  script:
    - export REACT_APP_UI_URL="$REACT_APP_UI_URL"
    - npm run test:acceptance
